unit FTPAccountsFrameUnit;

interface

uses
  Windows,

  SysUtils, Classes,

  Controls, ComCtrls, StdCtrls, Buttons, ExtCtrls, Forms, ToolWin, Menus, ImgList, Dialogs,

  FTPUtils;

type
  TFTPAccountsFrame = class(TFrame)
    Panel3: TPanel;
    Splitter1: TSplitter;
    GroupBox2: TGroupBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    CheckBox1: TCheckBox;
    ListBox1: TListBox;
    GroupBox3: TGroupBox;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    ListView1: TListView;
    GroupBox4: TGroupBox;
    SpeedButton7: TSpeedButton;
    TreeView1: TTreeView;
    Splitter2: TSplitter;
    ImageList2: TImageList;
    PopupMenu1: TPopupMenu;
    Setfolderpermissions1: TMenuItem;
    Nnone1: TMenuItem;
    RRead1: TMenuItem;
    WWrite1: TMenuItem;
    Setrecursivepermissions1: TMenuItem;
    Nnone2: TMenuItem;
    RRead2: TMenuItem;
    WWrite2: TMenuItem;
    CheckBox2: TCheckBox;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure CheckBox1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure WWrite1Click(Sender: TObject);
    procedure WWrite2Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure ToolButton1Click(Sender: TObject);
  private
    FUserManager:TFTPUserManager;
  public
    constructor Create(AOwner:TComponent);override;

    procedure UpdateGUI;
    procedure UpdateFTPFolderTree;
  published
    property UserManager:TFTPUserManager read FUserManager;
  end;

implementation

uses
  MainFormUnit, UserPropertiesFormUnit, ProgressFormUnit;

{$R *.dfm}

{ TFrame1 }

procedure TFTPAccountsFrame.CheckBox1Click(Sender: TObject);
begin
  FUserManager.AllowAnonymous:=CheckBox1.Checked;
  UpdateGUI;
end;

constructor TFTPAccountsFrame.Create(AOwner: TComponent);
begin
  inherited;
  FUserManager:=TFTPUserManager.Create;
end;

procedure TFTPAccountsFrame.ListBox1Click(Sender: TObject);
begin
  UpdateGUI;
end;

procedure TFTPAccountsFrame.ListView1Click(Sender: TObject);
var
  a:Integer;
begin
  with FUserManager.Group[ListBox1.ItemIndex] do
    for a:=0 to ListView1.Items.Count-1 do
      User[a].Active:=ListView1.Items[a].Checked;
  UpdateGUI;
end;

procedure TFTPAccountsFrame.ListView1SelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  UpdateGUI;
end;

procedure TFTPAccountsFrame.PopupMenu1Popup(Sender: TObject);
begin
  Setfolderpermissions1.Enabled:=Assigned(TreeView1.Selected) and
                                 (ListBox1.ItemIndex>-1) and
                                 FUserManager.Group[ListBox1.ItemIndex].CanChangeFolderPermission(PChar(TreeView1.Selected.Data));
  Setrecursivepermissions1.Enabled:=Setfolderpermissions1.Enabled;
end;

procedure TFTPAccountsFrame.SpeedButton1Click(Sender: TObject);
var
  s:string;
begin
  s:='Group'+IntToStr(FUserManager.GroupCount);
  if InputQuery('New user group','Group name',s) then
    FUserManager.AddGroup(s);
  UpdateGUI;
end;

procedure TFTPAccountsFrame.SpeedButton2Click(Sender: TObject);
begin
  FUserManager.DeleteGroup(ListBox1.ItemIndex);
  UpdateGUI;
end;

procedure TFTPAccountsFrame.SpeedButton3Click(Sender: TObject);
begin
  if UserPropertiesForm.Execute(nil) then 
    FUserManager.Group[ListBox1.ItemIndex].AddUser(UserPropertiesForm.Edit1.Text,UserPropertiesForm.Edit2.Text,UserPropertiesForm.Edit3.Text);
  UpdateGUI;
end;

procedure TFTPAccountsFrame.SpeedButton4Click(Sender: TObject);
var
  a:Integer;
begin
  with FUserManager.Group[ListBox1.ItemIndex] do
    for a:=UserCount-1 downto 0 do
      if ListView1.Items[a].Selected then
        DeleteUser(a);
  UpdateGUI;
end;

procedure TFTPAccountsFrame.SpeedButton5Click(Sender: TObject);
begin
  if Assigned(ListView1.Selected) and UserPropertiesForm.Execute(FUserManager.Group[ListBox1.ItemIndex].User[ListView1.Selected.Index]) then
    with FUserManager.Group[ListBox1.ItemIndex].User[ListView1.Selected.Index] do begin
      Username:=UserPropertiesForm.Edit1.Text;
      Password:=UserPropertiesForm.Edit2.Text;
      Realname:=UserPropertiesForm.Edit3.Text;
    end;
  UpdateGUI;
end;

procedure TFTPAccountsFrame.UpdateFTPFolderTree;
var
  a,b:Integer;

  procedure RecMakeNode(n:TTreeNode;Caption,Path:string);
  var
    a:Integer;
    m:TTreeNode;
    p:PChar;
    s:string;
  begin
    Inc(b);
    m:=TreeView1.Items.AddChild(n,Caption);
    s:=MainForm.LocalFileSystem1.CurrentDirectory+Path;
    GetMem(p,Length(s));
    CopyMemory(p,@s[2],Length(s)-1);
    p[Length(s)-1]:=#0;
    m.Data:=p;
    if m.Level mod 4=0 then begin
      ProgressForm.Panel1.Caption:=IntToStr(b)+' folders...';
      Application.ProcessMessages;
      if not ProgressForm.Visible then
        raise EAbort.Create('Interrupted');
    end;
    with MainForm.LocalFileSystem1.GetDirectoryFolderContent(MainForm.LocalFileSystem1.CurrentDirectory+Path) do begin
      for a:=0 to Count-1 do
        if Items[a].Folder then
          RecMakeNode(m,Items[a].FileName,Path+Items[a].FileName+'/');
      Destroy;
    end;
  end;

begin
  b:=0;
  ProgressForm.Show;
  MainForm.Enabled:=False;
  try
    try
      FUserManager.CleanPaths;
      for a:=0 to TreeView1.Items.Count-1 do
        FreeMem(PChar(TreeView1.Items[a].Data));
      TreeView1.Items.Clear;
      RecMakeNode(nil,'ROOT_FOLDER  ('+Copy(MainForm.LocalFileSystem1.CurrentDirectory,2,Length(MainForm.LocalFileSystem1.CurrentDirectory)-2)+')','');
      UpdateGUI;
    except
      on e:EAbort do
        MessageDlg('Operation interrupted, shared folder list may not be complete.',mtWarning,[mbOk],0);
      else
        raise;
    end;
  finally
    MainForm.Enabled:=True;
    if ProgressForm.Visible then
      ProgressForm.Hide;
  end;
end;

procedure TFTPAccountsFrame.UpdateGUI;
var
  a,b:Integer;
  l:TLogEntryType;
const
  T:array[False..True] of Integer=(3,0);
begin
  ListBox1.Items.BeginUpdate;
  try
    b:=ListBox1.ItemIndex;
    if ListBox1.Items.Count<>FUserManager.GroupCount then begin
      ListBox1.Items.Clear;
      for a:=0 to FUserManager.GroupCount-1 do
        ListBox1.Items.Add(FUserManager.Group[a].GroupName);
    end else
      for a:=0 to FUserManager.GroupCount-1 do
        ListBox1.Items[a]:=FUserManager.Group[a].GroupName;
    if (b=-1) or (b>=ListBox1.Items.Count) then
      ListBox1.ItemIndex:=ListBox1.Items.Count-1
    else
      ListBox1.ItemIndex:=b;
  finally
    ListBox1.Items.EndUpdate;
  end;
  if (ListBox1.ItemIndex>-1) and (ListBox1.ItemIndex<FUserManager.GroupCount) then begin
    TreeView1.Items.BeginUpdate;
    try
      for a:=0 to TreeView1.Items.Count-1 do
        with TreeView1.Items[a],FUserManager.Group[ListBox1.ItemIndex] do begin
          ImageIndex:=Integer(FolderPermission[PChar(Data)])+T[CanChangeFolderPermission(PChar(Data))];
          SelectedIndex:=ImageIndex;
        end;
    finally
      TreeView1.Items.EndUpdate;
    end;
    TreeView1.Invalidate;
    with FUserManager.Group[ListBox1.ItemIndex] do begin
      SpeedButton2.Enabled:=not IsAdmin;
      if IsAnonymous then begin
        ListView1.ClearSelection;
        ListView1.Enabled:=False;
        ListView1.Items.Clear;
        SpeedButton3.Enabled:=False;
      end else begin
        ListView1.Enabled:=True;
        SpeedButton3.Enabled:=True;
        ListView1.Items.BeginUpdate;
        try
          if ListView1.Items.Count<>UserCount then begin
            ListView1.ClearSelection;
            ListView1.Items.Clear;
            for a:=0 to UserCount-1 do
              with ListView1.Items.Add do begin
                Caption:=User[a].Username;
                SubItems.Add(User[a].Password);
                SubItems.Add(User[a].Realname);
                Checked:=User[a].Active;
              end;
          end else
            for a:=0 to UserCount-1 do begin
              ListView1.Items[a].SubItems.Clear;
              ListView1.Items[a].Caption:=User[a].Username;
              ListView1.Items[a].SubItems.Add(User[a].Password);
              ListView1.Items[a].SubItems.Add(User[a].Realname);
              ListView1.Items[a].Checked:=User[a].Active;
            end;
        finally
          ListView1.Items.EndUpdate;
        end;
      end;
    end;
    TreeView1.Enabled:=True;
  end else begin
    for a:=0 to TreeView1.Items.Count-1 do
      with TreeView1.Items[a] do begin
        ImageIndex:=0;
        SelectedIndex:=0;
      end;
    TreeView1.Invalidate;
    SpeedButton2.Enabled:=False;
    SpeedButton3.Enabled:=False;
    ListView1.Clear;
    ListView1.Enabled:=False;
    TreeView1.Enabled:=False;
  end;
  SpeedButton4.Enabled:=ListView1.SelCount>0;
  SpeedButton5.Enabled:=ListView1.SelCount=1;
  if CheckBox1.Checked xor FUserManager.AllowAnonymous then
    CheckBox1.Checked:=FUserManager.AllowAnonymous;
  for l:=Low(TLogEntryType) to High(TLogEntryType) do
    MainForm.FTPSecurityFrame1.CheckListBox1.Checked[Integer(l)]:=l in FUserManager.LogEntrySet;
  MainForm.FTPSecurityFrame1.CheckBox1.Checked:=FUserManager.UseAntiBruteForce;
  MainForm.FTPSecurityFrame1.UpDown1.Enabled:=FUserManager.UseAntiBruteForce;
  MainForm.FTPSecurityFrame1.UpDown1.Position:=FUserManager.MaxUnsuccessfullConnections;
  CheckBox2.Checked:=FUserManager.CaseSensitiveAccounts;
  if FUserManager.PermanentDelete then
    MainForm.FTPGeneralFrame1.ComboBox1.ItemIndex:=1
  else
    MainForm.FTPGeneralFrame1.ComboBox1.ItemIndex:=0;
  MainForm.FTPTrafficFrame1.UpDown1.Position:=FUserManager.MaxUploadSpeed div 1024;
  MainForm.FTPTrafficFrame1.UpDown2.Position:=FUserManager.MaxDownloadSpeed div 1024;
  TreeView1Change(nil,nil);
end;

procedure TFTPAccountsFrame.WWrite1Click(Sender: TObject);
begin
  if Assigned(TreeView1.Selected) and
     (ListBox1.ItemIndex>-1) and
     FUserManager.Group[ListBox1.ItemIndex].CanChangeFolderPermission(PChar(TreeView1.Selected.Data)) then
    FUserManager.Group[ListBox1.ItemIndex].FolderPermission[PChar(TreeView1.Selected.Data)]:=TFTPPermissions(TMenuItem(Sender).Tag);
  UpdateGUI;
end;

procedure TFTPAccountsFrame.WWrite2Click(Sender: TObject);

  procedure RecSetPerm(n:TTreeNode);
  var
    a:Integer;
  begin
    FUserManager.Group[ListBox1.ItemIndex].FolderPermission[PChar(n.Data)]:=TFTPPermissions(TMenuItem(Sender).Tag);
    for a:=0 to n.Count-1 do
      RecSetPerm(n.Item[a]);
  end;

begin
  if Assigned(TreeView1.Selected) and
     (ListBox1.ItemIndex>-1) and
     FUserManager.Group[ListBox1.ItemIndex].CanChangeFolderPermission(PChar(TreeView1.Selected.Data)) then
    RecSetPerm(TreeView1.Selected);
  UpdateGUI;
end;

procedure TFTPAccountsFrame.SpeedButton7Click(Sender: TObject);
begin
  UpdateFTPFolderTree;
end;

procedure TFTPAccountsFrame.TreeView1DblClick(Sender: TObject);
begin
  if Assigned(TreeView1.Selected) and FUserManager.Group[ListBox1.ItemIndex].CanChangeFolderPermission(PChar(TreeView1.Selected.Data)) then begin
    FUserManager.Group[ListBox1.ItemIndex].FolderPermission[PChar(TreeView1.Selected.Data)]:=TFTPPermissions((Integer(FUserManager.Group[ListBox1.ItemIndex].FolderPermission[PChar(TreeView1.Selected.Data)])+1) mod 3);
    TreeView1.Selected.Expand(False);
    UpdateGUI;
  end;
end;

procedure TFTPAccountsFrame.CheckBox2Click(Sender: TObject);
begin
  FUserManager.CaseSensitiveAccounts:=CheckBox2.Checked;
end;

procedure TFTPAccountsFrame.TreeView1Change(Sender: TObject;
  Node: TTreeNode);
var
  p:TFTPPermissions;
begin
  if Assigned(Treeview1.Selected) and (ListBox1.ItemIndex>-1) then
    with FUserManager.Group[ListBox1.ItemIndex],Treeview1.Selected do begin
      ToolBar1.Enabled:=CanChangeFolderPermission(PChar(Data));
      for p:=ftpNone to ftpWrite do begin
        ToolBar1.Buttons[Integer(p)].Down:=FolderPermission[PChar(Data)]=p;
        ToolBar1.Buttons[Integer(p)].Enabled:=True;
      end;
    end
  else begin
    ToolBar1.Enabled:=False;
    for p:=ftpNone to ftpWrite do
      ToolBar1.Buttons[Integer(p)].Down:=False;
  end;
end;

procedure TFTPAccountsFrame.ToolButton1Click(Sender: TObject);
begin
  with TToolButton(Sender) do
    if Assigned(TreeView1.Selected) and (ListBox1.ItemIndex>-1) then
      FUserManager.Group[ListBox1.ItemIndex].FolderPermission[PChar(TreeView1.Selected.Data)]:=TFTPPermissions(Tag);
  UpdateGUI;
end;

end.
