unit LogFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, SyncObjs, ExtCtrls, FTPUtils, IdTCPServer, Buttons,
  StdCtrls;

type
  TUserData=record
    Thread:TIdPeerThread;
    Date:TDateTime;
  end;
  PUserData=^TUserData;

  TLogForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Timer1: TTimer;
    ListView1: TListView;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    ListView2: TListView;
    SpeedButton3: TSpeedButton;
    ListView3: TListView;
    SpeedButton4: TSpeedButton;
    Panel1: TPanel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    SpeedButton5: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure ListView2SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure SpeedButton3Click(Sender: TObject);
    procedure TabSheet3Show(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FUserList:TThreadList;
  public
    property UserList:TThreadList read FUserList;

    procedure AddUser(Thread:TIdPeerThread);
    procedure RemoveUser(Thread:TIdPeerThread);
  end;

var
  LogForm: TLogForm;

implementation

uses IdIOHandlerSocket, IdComponent, MainFormUnit, TypInfo;

{$R *.dfm}

procedure TLogForm.AddUser(Thread: TIdPeerThread);
var
  p:PUserData;
begin
  New(p);
  p^.Thread:=Thread;
  p^.Date:=Now;
  FUserList.Add(p);
end;

procedure TLogForm.FormCreate(Sender: TObject);
begin
  FUserList:=TThreadList.Create;
end;

procedure TLogForm.FormDestroy(Sender: TObject);
begin
//  FUserList.Destroy;
end;

procedure TLogForm.RemoveUser(Thread: TIdPeerThread);
var
  l:TList;
  a,b:Integer;
begin
  l:=FUserList.LockList;
  try
    b:=-1;
    for a:=0 to l.Count-1 do
      if PUserData(l[a]).Thread=Thread then
        b:=a;
    if b>-1 then
      l.Delete(b);
  finally
    FUserList.UnlockList;
  end;
end;

procedure TLogForm.Timer1Timer(Sender: TObject);
var
  l,s:TList;
  t:TStringList;
  a:Integer;

  function DurationToStr(t:TDateTime):string;
  var
    a:Integer;
  begin
    if t<0 then
      t:=0;
    a:=Trunc(t);
    t:=Frac(t);
    if a div 7>0 then
      Result:=IntToStr(a div 7)+'w '
    else
      Result:='';
    if a mod 7>0 then
      Result:=Result+IntToStr(a mod 7)+'d ';
    Result:=Result+TimeToStr(t);
  end;

begin
  l:=FUserList.LockList;
  if l.Count>1 then
    MainForm.StatusBar1.Panels[3].Text:=IntToStr(l.Count)+' users connected'
  else
    MainForm.StatusBar1.Panels[3].Text:=IntToStr(l.Count)+' user connected';
  ListView1.Items.BeginUpdate;
  s:=TList.Create;
  try
    for a:=0 to ListView1.Items.Count-1 do
      if ListView1.Items[a].Selected then
        s.Add(ListView1.Items[a].Data);
    if ListView1.Items.Count<>l.Count then
      ListView1.ClearSelection;
    while ListView1.Items.Count<l.Count do
      ListView1.Items.Add;
    while ListView1.Items.Count>l.Count do
      ListView1.Items.Delete(ListView1.Items.Count-1);
    for a:=0 to l.Count-1 do
      with ListView1.Items[a],PUserData(l[a])^ do begin
        SubItems.Clear;
        Caption:=Thread.Connection.Socket.Binding.PeerIP+':'+IntToStr(Thread.Connection.Socket.Binding.PeerPort);
        Data:=l[a];
        if Assigned(Thread.Data) then
          with TFTPUserData(Thread.Data) do begin
            SubItems.Add('Yes');
            if Assigned(Group) then
              SubItems.Add(Group.GroupName)
            else
              SubItems.Add('');
            SubItems.Add(Username);
            if Assigned(User) then
              SubItems.Add(User.Realname)
            else
              SubItems.Add(Password);
          end
        else begin
          SubItems.Add('No');
          SubItems.Add('');
          SubItems.Add('');
          SubItems.Add('');
        end;
        SubItems.Add(DateTimeToStr(Date));
      end;
    for a:=0 to ListView1.Items.Count-1 do
      if s.IndexOf(ListView1.Items[a].Data)>-1 then
        ListView1.Items[a].Selected:=True;
  finally
    ListView1SelectItem(nil,nil,False);
    s.Destroy;
    ListView1.Items.EndUpdate;
    FUserList.UnlockList;
  end;

  MainForm.FTPAccountsFrame1.UserManager.Lock;
  ListView2.Items.BeginUpdate;
  t:=TStringList.Create;
  try
    for a:=0 to ListView2.Items.Count-1 do
      t.Add(ListView2.Items[a].Caption);
    if ListView2.Items.Count<>MainForm.FTPAccountsFrame1.UserManager.IPBanCount then
      ListView2.ClearSelection;
    while ListView2.Items.Count<MainForm.FTPAccountsFrame1.UserManager.IPBanCount do
      ListView2.Items.Add;
    while ListView2.Items.Count>MainForm.FTPAccountsFrame1.UserManager.IPBanCount do
      ListView2.Items.Delete(ListView2.Items.Count-1);
    for a:=0 to MainForm.FTPAccountsFrame1.UserManager.IPBanCount-1 do
      with ListView2.Items[a],MainForm.FTPAccountsFrame1.UserManager.IPBan[a] do begin
        SubItems.Clear;
        Caption:=IP;
        SubItems.Add(DateTimeToStr(BanTime));
        SubItems.Add(DurationToStr(BanTime+MainForm.FTPSecurityFrame1.UpDown2.Position-Now));
      end;
    for a:=0 to ListView2.Items.Count-1 do
      if t.IndexOf(ListView2.Items[a].Caption)>-1 then
        ListView2.Items[a].Selected:=True;
  finally
    t.Destroy;
    ListView2.Items.EndUpdate;
    MainForm.FTPAccountsFrame1.UserManager.UnLock;
  end;

  MainForm.FTPAccountsFrame1.UserManager.Lock;
  ListView3.Items.BeginUpdate;
  try
    if ListView3.Items.Count<>MainForm.FTPAccountsFrame1.UserManager.LogEntryCount then
      ListView3.ClearSelection;
    while ListView3.Items.Count<MainForm.FTPAccountsFrame1.UserManager.LogEntryCount do
      ListView3.Items.Add;
    while ListView3.Items.Count>MainForm.FTPAccountsFrame1.UserManager.LogEntryCount do
      ListView3.Items.Delete(ListView3.Items.Count-1);
    for a:=0 to MainForm.FTPAccountsFrame1.UserManager.LogEntryCount-1 do
      with ListView3.Items[a],MainForm.FTPAccountsFrame1.UserManager.LogEntry[a] do begin
        Caption:=DateTimeToStr(Time);
        SubItems.Add(IP);
        SubItems.Add(UserName);
        SubItems.Add(Copy(GetEnumName(TypeInfo(TLogEntryType),Integer(EntryType)),2,20));
        SubItems.Add(Description);
      end;
  finally
    ListView3.Items.EndUpdate;
    MainForm.FTPAccountsFrame1.UserManager.UnLock;
  end;
end;

procedure TLogForm.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  SpeedButton1.Enabled:=ListView1.SelCount>0;
  SpeedButton2.Enabled:=ListView1.SelCount>0;
end;

procedure TLogForm.SpeedButton1Click(Sender: TObject);
var
  a,b:Integer;
  l:TList;
begin
  l:=FUserList.LockList;
  try
    for a:=0 to ListView1.Items.Count-1 do
      if ListView1.Items[a].Selected then begin
        b:=l.IndexOf(ListView1.Items[a].Data);
        if b>-1 then begin
          PUserData(l[b]).Thread.Connection.Disconnect;
          l.Delete(b);
        end;
      end;
  finally
    FUserlist.UnlockList;
  end;
end;

procedure TLogForm.SpeedButton4Click(Sender: TObject);
begin
  MainForm.FTPAccountsFrame1.UserManager.ClearLog;
  Timer1Timer(nil);
end;

procedure TLogForm.ListView2SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  SpeedButton3.Enabled:=ListView2.SelCount>0;
end;

procedure TLogForm.SpeedButton3Click(Sender: TObject);
var
  a:Integer;
begin
  for a:=0 to ListView2.Items.Count-1 do
    if ListView2.Items[a].Selected then
      MainForm.FTPAccountsFrame1.UserManager.UnbanIP(ListView2.Items[a].Caption);
  Timer1Timer(nil);
end;

procedure TLogForm.TabSheet3Show(Sender: TObject);
begin
  Panel1.Parent:=TTabSheet(Sender);
  Panel1.Top:=TTabSheet(Sender).ClientHeight-Panel1.Height-10;
end;

procedure TLogForm.FormShow(Sender: TObject);
begin
  TabSheet3.OnShow:=TabSheet3Show;
  TabSheet2.OnShow:=TabSheet3Show;
  TabSheet1.OnShow:=TabSheet3Show;
  TabSheet3Show(PageControl1.ActivePage);
end;

procedure TLogForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  Timer1.Interval:=1000*UpDown1.Position;
end;

procedure TLogForm.SpeedButton5Click(Sender: TObject);
begin
  Timer1Timer(nil);
end;

procedure TLogForm.SpeedButton2Click(Sender: TObject);
var
  a,b:Integer;
  l:TList;
begin
  l:=FUserList.LockList;
  try
    for a:=0 to ListView1.Items.Count-1 do
      if ListView1.Items[a].Selected then begin
        b:=l.IndexOf(ListView1.Items[a].Data);
        if b>-1 then begin
          MainForm.FTPAccountsFrame1.UserManager.BanIP(PUserData(l[b]).Thread.Connection.Socket.Binding.PeerIP);
          PUserData(l[b]).Thread.Connection.Disconnect;
          l.Delete(b);
        end;
      end;
  finally
    FUserlist.UnlockList;
  end;
end;

procedure TLogForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caHide;
end;

end.
