unit MainFormUnit;

interface

uses
  Windows, Messages, ShellAPI, {API}

  SysUtils, Classes, Graphics, IniFiles, {Delphi objects}

  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPServer, IdFTPList, IdFTPServer, {Indy}

  Controls, ExtCtrls, ComCtrls, Menus, Dialogs, Forms, {Wn32 controls}

  XPStyleActnCtrls, XPMan, ActnList, ActnMan, {XP-style controls}

  FTPGeneralFrameUnit, FTPRootFolderFrameUnit, FTPAccountsFrameUnit, FTPSecurityFrameUnit, FTPTrafficFrameUnit, {Frames}

  FTPUtils, Leds, CustomFileSystem, LocalFileSystem, IdThreadMgr,
  IdThreadMgrDefault; {Additional custom units}

const
  WM_SYSTRAYICON=WM_USER+1;
  GIconCount=3;

type
  TIdDataChannelThreadAccess=class(TIdDataChannelThread)
  protected
  public
    property DataChannel:TIdTCPConnection read FDataChannel;
  end;

  TMainForm = class(TForm)
    IdFTPServer1: TIdFTPServer;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    XPManifest1: TXPManifest;
    TabSheet3: TTabSheet;
    LocalFileSystem1: TLocalFileSystem;
    TabSheet4: TTabSheet;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Importconfiguration1: TMenuItem;
    Exportconfiguration1: TMenuItem;
    N1: TMenuItem;
    Connect1: TMenuItem;
    Disconnect1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    ools1: TMenuItem;
    Resetconfiguration1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    ActionManager1: TActionManager;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    Action4: TAction;
    Action5: TAction;
    Action6: TAction;
    Action7: TAction;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PopupMenu1: TPopupMenu;
    Disconnect2: TMenuItem;
    About2: TMenuItem;
    N3: TMenuItem;
    About3: TMenuItem;
    Show1: TMenuItem;
    N4: TMenuItem;
    FTPGeneralFrame1: TFTPGeneralFrame;
    Action8: TAction;
    Action9: TAction;
    Action10: TAction;
    View1: TMenuItem;
    Connecteduserslist1: TMenuItem;
    Banlist1: TMenuItem;
    Filesystemlog1: TMenuItem;
    View2: TMenuItem;
    Filesystemlog2: TMenuItem;
    Banlist2: TMenuItem;
    Connecteduserslist2: TMenuItem;
    Timer1: TTimer;
    FTPSecurityFrame1: TFTPSecurityFrame;
    Timer2: TTimer;
    TabSheet5: TTabSheet;
    N5: TMenuItem;
    Action11: TAction;
    Expertmode1: TMenuItem;
    FTPAccountsFrame1: TFTPAccountsFrame;
    FTPRootFolderFrame1: TFTPRootFolderFrame;
    StatusBar1: TStatusBar;
    OnOffLed1: TOnOffLed;
    FTPTrafficFrame1: TFTPTrafficFrame;
    procedure IdFTPServer1ListDirectory(ASender: TIdFTPServerThread;
      const APath: String; ADirectoryListing: TIdFTPListItems);
    procedure IdFTPServer1ChangeDirectory(ASender: TIdFTPServerThread;
      var VDirectory: String);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure IdFTPServer1RetrieveFile(ASender: TIdFTPServerThread;
      const AFileName: String; var VStream: TStream);
    procedure IdFTPServer1GetFileSize(ASender: TIdFTPServerThread;
      const AFilename: String; var VFileSize: Int64);
    procedure IdFTPServer1StoreFile(ASender: TIdFTPServerThread;
      const AFileName: String; AAppend: Boolean; var VStream: TStream);
    procedure IdFTPServer1RenameFile(ASender: TIdFTPServerThread;
      const ARenameFromFile, ARenameToFile: String);
    procedure IdFTPServer1DeleteFile(ASender: TIdFTPServerThread;
      const APathName: String);
    procedure IdFTPServer1RemoveDirectory(ASender: TIdFTPServerThread;
      var VDirectory: String);
    procedure IdFTPServer1MakeDirectory(ASender: TIdFTPServerThread;
      var VDirectory: String);
    procedure IdFTPServer1UserLogin(ASender: TIdFTPServerThread;
      const AUsername, APassword: String; var AAuthenticated: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure TabSheet3Show(Sender: TObject);
    procedure Action3Execute(Sender: TObject);
    procedure Action4Execute(Sender: TObject);
    procedure Action1Execute(Sender: TObject);
    procedure Action2Execute(Sender: TObject);
    procedure Action6Execute(Sender: TObject);
    procedure Action5Execute(Sender: TObject);
    procedure Action7Execute(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure IdFTPServer1Disconnect(AThread: TIdPeerThread);
    procedure IdFTPServer1BeforeCommandHandler(ASender: TIdTCPServer;
      const AData: String; AThread: TIdPeerThread);
    procedure IdFTPServer1Connect(AThread: TIdPeerThread);
    procedure Action8Execute(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure IdFTPServer1AfterCommandHandler(ASender: TIdTCPServer;
      AThread: TIdPeerThread);
    procedure Timer2Timer(Sender: TObject);
    procedure LocalFileSystem1CurrentDirectoryChanging(Sender: TObject;
      NewDir: String);
    procedure LocalFileSystem1CurrentDirectoryChange(Sender: TObject);
    procedure Action11Execute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FFlashing:Integer;
    FIconIndex:Integer;
    FIcons:array[0..GIconCount-1] of TIcon;

    procedure WMSysTrayIcon(var Message:TMessage);message WM_SYSTRAYICON;
    procedure WMSysCommand(var Message:TMessage);message WM_SYSCOMMAND;

    procedure MakeIntercept(ASender:TidFTPServerThread);
  public
    NID:TNotifyIconData;

    procedure FlashOn;
    procedure FlashOff;

    procedure SaveSettings(FileName:string);
    procedure LoadSettings(FileName:string);

    procedure SwitchToExpert;
    procedure SwitchToNoob;
  end;

var
  MainForm: TMainForm;

implementation

uses Math, UserPropertiesFormUnit, AboutFormUnit, LogFormUnit;

{$R *.dfm}
{$R Images/Icons.res}

procedure TMainForm.IdFTPServer1ListDirectory(ASender: TIdFTPServerThread;
  const APath: String; ADirectoryListing: TIdFTPListItems);
begin
  MakeIntercept(ASender);
  TFTPUserData(ASender.Data).GetDirectoryListing(APath,ADirectoryListing);
end;

procedure TMainForm.IdFTPServer1ChangeDirectory(ASender: TIdFTPServerThread;
  var VDirectory: String);
begin
  MakeIntercept(ASender);
  TFTPUserData(ASender.Data).ChangeDirectory(VDirectory);
end;

procedure TMainForm.IdFTPServer1GetFileSize(ASender: TIdFTPServerThread;
  const AFilename: String; var VFileSize: Int64);
begin
  MakeIntercept(ASender);
  TFTPUserData(ASender.Data).GetFileSize(AFileName,VFileSize);
end;

procedure TMainForm.IdFTPServer1RetrieveFile(ASender: TIdFTPServerThread;
  const AFileName: String; var VStream: TStream);
begin
  MakeIntercept(ASender);
  TFTPUserData(ASender.Data).RetrieveFile(AFileName,VStream);
end;

procedure TMainForm.IdFTPServer1StoreFile(ASender: TIdFTPServerThread;
  const AFileName: String; AAppend: Boolean; var VStream: TStream);
begin
  MakeIntercept(ASender);
  TFTPUserData(ASender.Data).StoreFile(AFileName,AAppend,VStream);
end;

procedure TMainForm.IdFTPServer1RenameFile(ASender: TIdFTPServerThread;
  const ARenameFromFile, ARenameToFile: String);
begin
  MakeIntercept(ASender);
  TFTPUserData(ASender.Data).RenameFile(ARenameFromFile,ARenameToFile);
end;

procedure TMainForm.IdFTPServer1MakeDirectory(ASender: TIdFTPServerThread;
  var VDirectory: String);
begin
  MakeIntercept(ASender);
  TFTPUserData(ASender.Data).MakeDirectory(VDirectory);
end;

procedure TMainForm.IdFTPServer1DeleteFile(ASender: TIdFTPServerThread;
  const APathName: String);
begin
  MakeIntercept(ASender);
  TFTPUserData(ASender.Data).DeleteFile(APathName);
end;

procedure TMainForm.IdFTPServer1RemoveDirectory(
  ASender: TIdFTPServerThread; var VDirectory: String);
begin
  MakeIntercept(ASender);
  TFTPUserData(ASender.Data).RemoveDirectory(VDirectory);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  a:Integer;
  s:TResourceStream;
begin
  OnOffLed1.Parent:=StatusBar1;
  with StatusBar1,StatusBar1.Panels[0] do
    OnOffLed1.SetBounds(Width-18,1,12,ClientHeight);
  IdFTPServer1.Intercept:=TServerTrafficIntercept.Create(Self);
  TServerTrafficIntercept(IdFTPServer1.Intercept).UserManager:=FTPAccountsFrame1.UserManager;
  for a:=0 to GIconCount-1 do begin
    FIcons[a]:=TIcon.Create;
    s:=TResourceStream.Create(HInstance,'ICON'+IntToStr(a),'RT_ICON');
    s.Position:=0;
    FIcons[a].LoadFromStream(s);
    s.Destroy;
  end;
  Icon:=FIcons[0];
  FTPGeneralFrame1.BitBtn1.Action:=Action3;
  FTPGeneralFrame1.BitBtn2.Action:=Action4;
  FTPSecurityFrame1.SpeedButton1.Action:=Action9;
  FTPSecurityFrame1.SpeedButton2.Action:=Action10;
  FTPRootFolderFrame1.FolderTreeExplorer1.FileSystem:=LocalFileSystem1;
  LocalFileSystem1.Connect;
  FTPAccountsFrame1.UserManager.LoadLog(ExtractFilePath(Application.ExeName)+'FTP.log');
  LoadSettings(ChangeFileExt(Application.ExeName,'.dat'));
  if FTPGeneralFrame1.CheckBox1.Checked then
    FTPGeneralFrame1.ConnectServer;
  if FTPGeneralFrame1.CheckBox2.Checked and (ParamStr(1)='-AutoLaunch') and IdFTPServer1.Active then
    Perform(WM_SYSCOMMAND,SC_MINIMIZE,0)
  else
    WindowState:=wsMaximized;
end;

procedure TMainForm.SpeedButton6Click(Sender: TObject);
begin
  LocalFileSystem1.UpdateHooks;
end;

procedure TMainForm.IdFTPServer1UserLogin(ASender: TIdFTPServerThread;
  const AUsername, APassword: String; var AAuthenticated: Boolean);
begin
  ASender.Data:=FTPAccountsFrame1.UserManager.CreateUserData(ASender,AUsername,APassword);
  AAuthenticated:=Assigned(ASender.Data);
  if not AAuthenticated then
    Sleep(FTPSecurityFrame1.UpDown3.Position*1000);
end;

procedure TMainForm.LoadSettings(FileName: string);
var
  f:TMemIniFile;
  m:TMemoryStream;
begin
  f:=TMemIniFile.Create(FileName);
  m:=TMemoryStream.Create;
  try
    if f.ReadBool('General','Expert',False) then 
      SwitchToExpert
    else
      SwitchToNoob;
    FTPGeneralFrame1.UpDown1.Position:=f.ReadInteger('General','DefaultPort',21);
    FTPGeneralFrame1.UpDown2.Position:=f.ReadInteger('General','DataPort',20);
    FTPGeneralFrame1.CheckBox1.Checked:=f.ReadBool('General','AutoConnect',False);
    FTPGeneralFrame1.CheckBox2.Checked:=f.ReadBool('General','MinimizeToTray',True);
    FTPGeneralFrame1.CheckBox3.Checked:=f.ReadBool('General','AutoLaunch',False);
    FTPSecurityFrame1.UpDown2.Position:=f.ReadInteger('General','BanDuration',10);
    FTPSecurityFrame1.UpDown3.Position:=f.ReadInteger('General','ReconnectionDelay',4);
    FTPSecurityFrame1.UpDown4.Position:=f.ReadInteger('General','LogHistoryDays',10);
    FTPSecurityFrame1.CheckBox2.Checked:=f.ReadBool('General','EnableDebugHistory',False);
    f.ReadBinaryStream('General','FTPGreeting',m);
    m.Position:=0;
    FTPGeneralFrame1.RichEdit1.Lines.LoadFromStream(m);
    if FTPGeneralFrame1.RichEdit1.Text='' then
      FTPGeneralFrame1.RichEdit1.Text:='FTP server ready, proceed';
    FTPAccountsFrame1.UserManager.ReadFromIniFile(f);
    LocalFileSystem1.CurrentDirectory:='/'+FTPAccountsFrame1.UserManager.RootPath+'/';
  finally
    FTPGeneralFrame1.CheckBox3Click(nil);
    m.Destroy;
    f.Destroy;
    FTPAccountsFrame1.UpdateGUI;
  end;
end;

procedure TMainForm.SaveSettings(FileName: string);
var
  f:TMemIniFile;
  m:TMemoryStream;
begin
  f:=TMemIniFile.Create(FileName);
  m:=TMemoryStream.Create;
  try
    f.Clear;
    f.WriteBool('General','Expert',Action11.Checked);
    f.WriteInteger('General','DefaultPort',FTPGeneralFrame1.UpDown1.Position);
    f.WriteInteger('General','DataPort',FTPGeneralFrame1.UpDown2.Position);
    f.WriteBool('General','AutoConnect',FTPGeneralFrame1.CheckBox1.Checked);
    f.WriteBool('General','MinimizeToTray',FTPGeneralFrame1.CheckBox2.Checked);
    f.WriteBool('General','AutoLaunch',FTPGeneralFrame1.CheckBox3.Checked);
    f.WriteInteger('General','BanDuration',FTPSecurityFrame1.UpDown2.Position);
    f.WriteInteger('General','ReconnectionDelay',FTPSecurityFrame1.UpDown3.Position);
    f.WriteInteger('General','LogHistoryDays',FTPSecurityFrame1.UpDown4.Position);
    f.WriteBool('General','EnableDebugHistory',FTPSecurityFrame1.CheckBox2.Checked);
    FTPGeneralFrame1.RichEdit1.Lines.SaveToStream(m);
    m.Position:=0;
    f.WriteBinaryStream('General','FTPGreeting',m);
    FTPAccountsFrame1.UserManager.WriteToIniFile(f);
    f.UpdateFile;
  finally
    m.Destroy;
    f.Destroy;
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Timer1Timer(nil);
  SaveSettings(ChangeFileExt(Application.ExeName,'.dat'));
  if NID.cbSize<>0 then
    Shell_NotifyIcon(NIM_DELETE,@NID);
end;

procedure TMainForm.TabSheet3Show(Sender: TObject);
begin
  FTPAccountsFrame1.UpdateFTPFolderTree;
end;

procedure TMainForm.Action3Execute(Sender: TObject);
begin
  FTPGeneralFrame1.ConnectServer;
end;

procedure TMainForm.Action4Execute(Sender: TObject);
begin
  FTPGeneralFrame1.DisconnectServer;
end;

procedure TMainForm.Action1Execute(Sender: TObject);
begin
  if OpenDialog1.Execute then
    LoadSettings(OpenDialog1.FileName);
end;

procedure TMainForm.Action2Execute(Sender: TObject);
begin
  if SaveDialog1.Execute then
    SaveSettings(SaveDialog1.FileName);
end;

procedure TMainForm.Action6Execute(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to reset the configuration to default settings?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
    LoadSettings('');
end;

procedure TMainForm.WMSysCommand(var Message: TMessage);
var
  s:string;
begin
  if (Message.WParam=SC_MINIMIZE) and IdFTPServer1.Active and FTPGeneralFrame1.CheckBox2.Checked then begin
    NID.cbSize:=SizeOf(NID);
    NID.Wnd:=Handle;
    NID.uID:=1;
    NID.uCallbackMessage:=WM_SYSTRAYICON;
    NID.hIcon:=Icon.Handle;
    s:=Caption+' (connected)';
    ZeroMemory(@NID.szTip[0],64);
    CopyMemory(@NID.szTip[0],@s[1],Length(s));
    NID.uFlags:=NIF_MESSAGE or NIF_ICON or NIF_TIP;
    Assert(Shell_NotifyIcon(Nim_ADD,@NID),SysErrorMessage(GetLastError));
    Application.ShowMainForm:=False;
    Hide;
  end else
    inherited;
end;

procedure TMainForm.WMSysTrayIcon(var Message: TMessage);
var
  p:TPoint;
begin
  case Message.LParam of
    WM_LBUTTONDBLCLK:begin
      Show;
      Shell_NotifyIcon(NIM_DELETE,@NID);
      ZeroMemory(@NID,SizeOf(NID));
    end;
    WM_RBUTTONUP:begin
      GetCursorPos(p);
      PopupMenu1.Popup(p.X,p.Y);
    end;
  end;
end;

procedure TMainForm.Action5Execute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.Action7Execute(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.Show1Click(Sender: TObject);
begin
  Perform(WM_SYSTRAYICON,0,WM_LBUTTONDBLCLK);
end;

procedure TMainForm.IdFTPServer1Disconnect(AThread: TIdPeerThread);
begin
  LogForm.RemoveUser(AThread);
end;

procedure TMainForm.IdFTPServer1BeforeCommandHandler(ASender: TIdTCPServer;
  const AData: String; AThread: TIdPeerThread);
begin
  FlashOn;
  if not FTPSecurityFrame1.CheckBox2.Checked then
    Exit;
  while (FTPSecurityFrame1.ListBox1.Items.Count>0) and
        (FTPSecurityFrame1.ListBox1.ItemHeight*Ceil((FTPSecurityFrame1.ListBox1.Count+1)*0.5)>FTPSecurityFrame1.ListBox1.ClientHeight) do
    FTPSecurityFrame1.ListBox1.Items.Delete(0);
  FTPSecurityFrame1.ListBox1.AddItem(AData,nil);
end;

procedure TMainForm.IdFTPServer1Connect(AThread: TIdPeerThread);
begin
  LogForm.AddUser(AThread);
end;

procedure TMainForm.Action8Execute(Sender: TObject);
begin
  LogForm.PageControl1.TabIndex:=TAction(Sender).Tag;
  LogForm.Show;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var
  a:Integer;
begin
  FTPAccountsFrame1.UserManager.Lock;
  try
    for a:=FTPAccountsFrame1.UserManager.IPBanCount-1 downto 0 do
      if Now-FTPAccountsFrame1.UserManager.IPBan[a].BanTime>=FTPSecurityFrame1.UpDown2.Position then
        FTPAccountsFrame1.UserManager.UnbanIP(FTPAccountsFrame1.UserManager.IPBan[a].IP);
  finally
    FTPAccountsFrame1.UserManager.UnLock;
  end;
  FTPAccountsFrame1.UserManager.ClearOldLog(FTPSecurityFrame1.Updown4.Position);
  FTPAccountsFrame1.UserManager.SaveLog(ExtractFilePath(Application.ExeName)+'FTP.log');
end;

procedure TMainForm.IdFTPServer1AfterCommandHandler(ASender: TIdTCPServer;
  AThread: TIdPeerThread);
begin
  FlashOff;
end;

procedure TMainForm.FlashOff;
begin
  //FFlashing:=2;
end;

procedure TMainForm.FlashOn;
begin
  if FIconIndex=0 then
    FIconIndex:=1;
  FFlashing:=2;
  if not Timer2.Enabled then
    Timer2.Enabled:=True;
end;

procedure TMainForm.Timer2Timer(Sender: TObject);
var
  i:TIcon;
begin
  if FFlashing=0 then begin
    i:=FIcons[0];
    FIconIndex:=0;
    Timer2.Enabled:=False;
  end else begin
    FIconIndex:=1+(FIconIndex mod (GIconCount-1));
    i:=FIcons[FIconIndex];
    if FTPTrafficFrame1.SendRate+FTPTrafficFrame1.ReceiveRate=0 then
      Dec(FFlashing);
  end;
  Icon:=i;
  if NID.cbSize<>0 then begin
    NID.hIcon:=i.Handle;
    Shell_NotifyIcon(NIM_MODIFY,@NID);
  end;
end;

procedure TMainForm.LocalFileSystem1CurrentDirectoryChanging(
  Sender: TObject; NewDir: String);
begin
  if NewDir='/' then begin
    MessageDlg('This folder cannot be used as FTP root directory',mtError,[mbOk],0);
    NewDir:='/C:/';
  end;
end;

procedure TMainForm.LocalFileSystem1CurrentDirectoryChange(
  Sender: TObject);
begin
  if LocalFileSystem1.CurrentDirectory<>'/' then begin
    FTPRootFolderFrame1.Edit1.Text:=Copy(LocalFileSystem1.CurrentDirectory,2,Length(LocalFileSystem1.CurrentDirectory)-2);
    if Assigned(FTPAccountsFrame1.UserManager) then
      FTPAccountsFrame1.UserManager.RootPath:=Copy(LocalFileSystem1.CurrentDirectory,2,Length(LocalFileSystem1.CurrentDirectory)-2);
  end;
end;

procedure TMainForm.MakeIntercept(ASender: TidFTPServerThread);
begin
  if Assigned(Asender.DataChannelThread) and
     Assigned(TIdDataChannelThreadAccess(ASender.DataChannelThread).DataChannel)
     and not Assigned(TIdDataChannelThreadAccess(ASender.DataChannelThread).DataChannel.Intercept) then
    TIdDataChannelThreadAccess(ASender.DataChannelThread).DataChannel.Intercept:=IdFTPServer1.Intercept.Accept(TIdDataChannelThreadAccess(ASender.DataChannelThread).DataChannel);
    //TIdDataChannelThreadAccess(ASender.DataChannelThread).DataChannel.Intercept:=ASender.Connection.Intercept;
end;

procedure TMainForm.Action11Execute(Sender: TObject);
begin
  if not Action11.Checked then
    SwitchToExpert
  else
    SwitchToNoob;
end;

procedure TMainForm.SwitchToExpert;
begin
  Action11.Checked:=True;
  TabSheet4.TabVisible:=True;
  Action8.Visible:=True;
  Action9.Visible:=True;
  Action10.Visible:=True;
  FTPGeneralFrame1.Panel1.Visible:=True;
  FTPGeneralFrame1.Panel2.Visible:=True;
end;

procedure TMainForm.SwitchToNoob;
begin
  Action11.Checked:=False;
  TabSheet4.TabVisible:=False;
  Action8.Visible:=False;
  Action9.Visible:=False;
  Action10.Visible:=False;
  FTPGeneralFrame1.Panel1.Visible:=False;
  FTPGeneralFrame1.Panel2.Visible:=False;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if IdFTPServer1.Active then
    FTPGeneralFrame1.DisconnectServer;
  if IdFTPServer1.Active then
    Action:=caNone
  else
    Action:=caFree;
end;

end.
